/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

/* ***********************************************************
* This file was automatically generated on 2020-04-29.      *
*                                                           *
* openHAB Bindings Version 2.0.0                            *
*                                                           *
* If you have a bugfix for this file and want to commit it, *
* please fix the bug in the generator. You can find a link  *
* to the generators git repository on tinkerforge.com       *
*************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import com.tinkerforge.BrickletIndustrialDigitalOut4;
import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Industrial Digital Out 4 Bricklet.
 * 
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialDigitalOut4Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) {
        this.handler = (DeviceHandler) handler;
    }

    @Override
    public @Nullable ThingHandler getThingHandler() {
        return handler;
    }

    @RuleAction(label = "Set Value")
    public void brickletIndustrialDigitalOut4SetValue(@ActionInput(name = "valueMask") int valueMask)
            throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable
        BrickletIndustrialDigitalOut4Wrapper dev = ((@Nullable BrickletIndustrialDigitalOut4Wrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setValue(valueMask);
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3"),
                    RefreshType.REFRESH);
        }
    }

    public static void brickletIndustrialDigitalOut4SetValue(@Nullable ThingActions actions, int valueMask)
            throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4SetValue(valueMask);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Set Selected Values")
    public void brickletIndustrialDigitalOut4SetSelectedValues(@ActionInput(name = "selectionMask") int selectionMask,
            @ActionInput(name = "valueMask") int valueMask) throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable
        BrickletIndustrialDigitalOut4Wrapper dev = ((@Nullable BrickletIndustrialDigitalOut4Wrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setSelectedValues(selectionMask, valueMask);
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3"),
                    RefreshType.REFRESH);
        }
    }

    public static void brickletIndustrialDigitalOut4SetSelectedValues(@Nullable ThingActions actions, int selectionMask,
            int valueMask) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            ((BrickletIndustrialDigitalOut4Actions) actions)
                    .brickletIndustrialDigitalOut4SetSelectedValues(selectionMask, valueMask);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Set Monoflop")
    public void brickletIndustrialDigitalOut4SetMonoflop(@ActionInput(name = "selectionMask") int selectionMask,
            @ActionInput(name = "valueMask") int valueMask, @ActionInput(name = "time") long time)
            throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable
        BrickletIndustrialDigitalOut4Wrapper dev = ((@Nullable BrickletIndustrialDigitalOut4Wrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setMonoflop(selectionMask, valueMask, time);
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4OutputPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2"),
                    RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3"),
                    RefreshType.REFRESH);
        }
    }

    public static void brickletIndustrialDigitalOut4SetMonoflop(@Nullable ThingActions actions, int selectionMask,
            int valueMask, long time) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4SetMonoflop(selectionMask,
                    valueMask, time);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Get Value")
    public @ActionOutput(name = "valueMask", type = "int") Map<String, Object> brickletIndustrialDigitalOut4GetValue()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIndustrialDigitalOut4Wrapper dev = ((@Nullable BrickletIndustrialDigitalOut4Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getValue();

        result.put("valueMask", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDigitalOut4GetValue(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            return ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4GetValue();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Get Monoflop")
    public @ActionOutput(name = "value", type = "int") @ActionOutput(name = "time", type = "long") @ActionOutput(name = "timeRemaining", type = "long") Map<String, Object> brickletIndustrialDigitalOut4GetMonoflop(
            @ActionInput(name = "pin") short pin) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIndustrialDigitalOut4Wrapper dev = ((@Nullable BrickletIndustrialDigitalOut4Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletIndustrialDigitalOut4.Monoflop value = dev.getMonoflop(pin);

        result.put("value", value.value);
        result.put("time", value.time);
        result.put("timeRemaining", value.timeRemaining);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDigitalOut4GetMonoflop(@Nullable ThingActions actions,
            short pin) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            return ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4GetMonoflop(pin);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type = "String") @ActionOutput(name = "connectedUid", type = "String") @ActionOutput(name = "position", type = "char") @ActionOutput(name = "hardwareVersion", type = "short[]") @ActionOutput(name = "firmwareVersion", type = "short[]") @ActionOutput(name = "deviceIdentifier", type = "int") Map<String, Object> brickletIndustrialDigitalOut4GetIdentity()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIndustrialDigitalOut4Wrapper dev = ((@Nullable BrickletIndustrialDigitalOut4Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletIndustrialDigitalOut4.Identity value = dev.getIdentity();

        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDigitalOut4GetIdentity(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            return ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4GetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }
}
