/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

/* ***********************************************************
* This file was automatically generated on 2020-04-29.      *
*                                                           *
* openHAB Bindings Version 2.0.0                            *
*                                                           *
* If you have a bugfix for this file and want to commit it, *
* please fix the bug in the generator. You can find a link  *
* to the generators git repository on tinkerforge.com       *
*************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import com.tinkerforge.BrickletUVLightV2;
import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the UV Light Bricklet 2.0.
 * 
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletUVLightV2Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) {
        this.handler = (DeviceHandler) handler;
    }

    @Override
    public @Nullable ThingHandler getThingHandler() {
        return handler;
    }

    @RuleAction(label = "Get UVA")
    public @ActionOutput(name = "uva", type = "int") Map<String, Object> brickletUVLightV2GetUVA()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getUVA();

        result.put("uva", value);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2GetUVA(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2GetUVA();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get UVB")
    public @ActionOutput(name = "uvb", type = "int") Map<String, Object> brickletUVLightV2GetUVB()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getUVB();

        result.put("uvb", value);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2GetUVB(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2GetUVB();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get UVI")
    public @ActionOutput(name = "uvi", type = "int") Map<String, Object> brickletUVLightV2GetUVI()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getUVI();

        result.put("uvi", value);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2GetUVI(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2GetUVI();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get Configuration")
    public @ActionOutput(name = "integrationTime", type = "int") Map<String, Object> brickletUVLightV2GetConfiguration()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getConfiguration();

        result.put("integrationTime", value);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2GetConfiguration(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2GetConfiguration();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type = "long") Map<String, Object> brickletUVLightV2ReadUID()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        long value = dev.readUID();

        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2ReadUID(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2ReadUID();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type = "int") Map<String, Object> brickletUVLightV2GetChipTemperature()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getChipTemperature();

        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2GetChipTemperature(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2GetChipTemperature();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type = "int") Map<String, Object> brickletUVLightV2GetStatusLEDConfig()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getStatusLEDConfig();

        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2GetStatusLEDConfig(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2GetStatusLEDConfig();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type = "long") @ActionOutput(name = "errorCountMessageChecksum", type = "long") @ActionOutput(name = "errorCountFrame", type = "long") @ActionOutput(name = "errorCountOverflow", type = "long") Map<String, Object> brickletUVLightV2GetSPITFPErrorCount()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletUVLightV2.SPITFPErrorCount value = dev.getSPITFPErrorCount();

        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2GetSPITFPErrorCount(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2GetSPITFPErrorCount();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type = "String") @ActionOutput(name = "connectedUid", type = "String") @ActionOutput(name = "position", type = "char") @ActionOutput(name = "hardwareVersion", type = "short[]") @ActionOutput(name = "firmwareVersion", type = "short[]") @ActionOutput(name = "deviceIdentifier", type = "int") Map<String, Object> brickletUVLightV2GetIdentity()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletUVLightV2Wrapper dev = ((@Nullable BrickletUVLightV2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletUVLightV2.Identity value = dev.getIdentity();

        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletUVLightV2GetIdentity(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).brickletUVLightV2GetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }
}
